/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/doc/demo-genom3/work/templates/ros/client/ros/demo_ros/srv/GetSpeed.srv
 *
 */


#ifndef DEMO_ROS_MESSAGE_GETSPEEDRESPONSE_H
#define DEMO_ROS_MESSAGE_GETSPEEDRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <demo_ros/demo_speed.h>

namespace demo_ros
{
template <class ContainerAllocator>
struct GetSpeedResponse_
{
  typedef GetSpeedResponse_<ContainerAllocator> Type;

  GetSpeedResponse_()
    : genom_success(false)
    , genom_exdetail()
    , speedRef()  {
    }
  GetSpeedResponse_(const ContainerAllocator& _alloc)
    : genom_success(false)
    , genom_exdetail(_alloc)
    , speedRef(_alloc)  {
    }



   typedef uint8_t _genom_success_type;
  _genom_success_type genom_success;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _genom_exdetail_type;
  _genom_exdetail_type genom_exdetail;

   typedef  ::demo_ros::demo_speed_<ContainerAllocator>  _speedRef_type;
  _speedRef_type speedRef;




  typedef boost::shared_ptr< ::demo_ros::GetSpeedResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::demo_ros::GetSpeedResponse_<ContainerAllocator> const> ConstPtr;

}; // struct GetSpeedResponse_

typedef ::demo_ros::GetSpeedResponse_<std::allocator<void> > GetSpeedResponse;

typedef boost::shared_ptr< ::demo_ros::GetSpeedResponse > GetSpeedResponsePtr;
typedef boost::shared_ptr< ::demo_ros::GetSpeedResponse const> GetSpeedResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::demo_ros::GetSpeedResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace demo_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'demo_ros': ['demo_ros/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::demo_ros::GetSpeedResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::demo_ros::GetSpeedResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::demo_ros::GetSpeedResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "573e4c7684e14f0e7fc702e62d44c8a7";
  }

  static const char* value(const ::demo_ros::GetSpeedResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x573e4c7684e14f0eULL;
  static const uint64_t static_value2 = 0x7fc702e62d44c8a7ULL;
};

template<class ContainerAllocator>
struct DataType< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "demo_ros/GetSpeedResponse";
  }

  static const char* value(const ::demo_ros::GetSpeedResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool genom_success\n\
string genom_exdetail\n\
demo_speed speedRef\n\
\n\
\n\
================================================================================\n\
MSG: demo_ros/demo_speed\n\
# IDL enum ::demo::speed\n\
uint32 demo_SLOW = 0\n\
uint32 demo_FAST = 1\n\
\n\
uint32 value\n\
";
  }

  static const char* value(const ::demo_ros::GetSpeedResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.genom_success);
      stream.next(m.genom_exdetail);
      stream.next(m.speedRef);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct GetSpeedResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::demo_ros::GetSpeedResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::demo_ros::GetSpeedResponse_<ContainerAllocator>& v)
  {
    s << indent << "genom_success: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.genom_success);
    s << indent << "genom_exdetail: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.genom_exdetail);
    s << indent << "speedRef: ";
    s << std::endl;
    Printer< ::demo_ros::demo_speed_<ContainerAllocator> >::stream(s, indent + "  ", v.speedRef);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DEMO_ROS_MESSAGE_GETSPEEDRESPONSE_H
