/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/doc/demo-genom3/work/templates/ros/client/ros/demo_ros/msg/demo_state.msg
 *
 */


#ifndef DEMO_ROS_MESSAGE_DEMO_STATE_H
#define DEMO_ROS_MESSAGE_DEMO_STATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace demo_ros
{
template <class ContainerAllocator>
struct demo_state_
{
  typedef demo_state_<ContainerAllocator> Type;

  demo_state_()
    : position(0.0)
    , speed(0.0)  {
    }
  demo_state_(const ContainerAllocator& _alloc)
    : position(0.0)
    , speed(0.0)  {
    }



   typedef double _position_type;
  _position_type position;

   typedef double _speed_type;
  _speed_type speed;




  typedef boost::shared_ptr< ::demo_ros::demo_state_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::demo_ros::demo_state_<ContainerAllocator> const> ConstPtr;

}; // struct demo_state_

typedef ::demo_ros::demo_state_<std::allocator<void> > demo_state;

typedef boost::shared_ptr< ::demo_ros::demo_state > demo_statePtr;
typedef boost::shared_ptr< ::demo_ros::demo_state const> demo_stateConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::demo_ros::demo_state_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::demo_ros::demo_state_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace demo_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'demo_ros': ['demo_ros/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::demo_ros::demo_state_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::demo_ros::demo_state_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::demo_ros::demo_state_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::demo_ros::demo_state_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::demo_ros::demo_state_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::demo_ros::demo_state_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::demo_ros::demo_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7f3fa819a0a98b5b6d1f155f218ff509";
  }

  static const char* value(const ::demo_ros::demo_state_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7f3fa819a0a98b5bULL;
  static const uint64_t static_value2 = 0x6d1f155f218ff509ULL;
};

template<class ContainerAllocator>
struct DataType< ::demo_ros::demo_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "demo_ros/demo_state";
  }

  static const char* value(const ::demo_ros::demo_state_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::demo_ros::demo_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::demo::state\n\
float64 position\n\
float64 speed\n\
";
  }

  static const char* value(const ::demo_ros::demo_state_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::demo_ros::demo_state_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.position);
      stream.next(m.speed);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct demo_state_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::demo_ros::demo_state_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::demo_ros::demo_state_<ContainerAllocator>& v)
  {
    s << indent << "position: ";
    Printer<double>::stream(s, indent + "  ", v.position);
    s << indent << "speed: ";
    Printer<double>::stream(s, indent + "  ", v.speed);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DEMO_ROS_MESSAGE_DEMO_STATE_H
